#pragma once

#include "common.h"
#include "chisqrdistri.h"

using namespace ChiSqrD;

namespace SimuU {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// DrawGraph ̊Tv
	/// </summary>
	public ref class DrawGraph : public System::Windows::Forms::Form
	{
	public:
		DrawGraph(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^[ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~DrawGraph()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  buttonSave;
	protected: 
	private: System::Windows::Forms::Button^  buttonClose;
	private: System::Windows::Forms::PictureBox^  pictureBox1;
	private: System::Windows::Forms::SaveFileDialog^  saveFileDialog1;


	protected: 

	private:
		/// <summary>
		/// KvȃfUCi[ϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi[ T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^[ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->buttonSave = (gcnew System::Windows::Forms::Button());
			this->buttonClose = (gcnew System::Windows::Forms::Button());
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->saveFileDialog1 = (gcnew System::Windows::Forms::SaveFileDialog());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->pictureBox1))->BeginInit();
			this->SuspendLayout();
			// 
			// buttonSave
			// 
			this->buttonSave->Location = System::Drawing::Point(12, 1);
			this->buttonSave->Name = L"buttonSave";
			this->buttonSave->Size = System::Drawing::Size(75, 23);
			this->buttonSave->TabIndex = 0;
			this->buttonSave->Text = L"Save";
			this->buttonSave->UseVisualStyleBackColor = true;
			this->buttonSave->Click += gcnew System::EventHandler(this, &DrawGraph::buttonSave_Click);
			// 
			// buttonClose
			// 
			this->buttonClose->Location = System::Drawing::Point(136, 1);
			this->buttonClose->Name = L"buttonClose";
			this->buttonClose->Size = System::Drawing::Size(75, 23);
			this->buttonClose->TabIndex = 1;
			this->buttonClose->Text = L"Close";
			this->buttonClose->UseVisualStyleBackColor = true;
			this->buttonClose->Click += gcnew System::EventHandler(this, &DrawGraph::buttonClose_Click);
			// 
			// pictureBox1
			// 
			this->pictureBox1->Location = System::Drawing::Point(70, 91);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(100, 50);
			this->pictureBox1->TabIndex = 2;
			this->pictureBox1->TabStop = false;
			// 
			// DrawGraph
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(284, 262);
			this->Controls->Add(this->pictureBox1);
			this->Controls->Add(this->buttonClose);
			this->Controls->Add(this->buttonSave);
			this->Name = L"DrawGraph";
			this->Text = L"DrawGraph";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->pictureBox1))->EndInit();
			this->ResumeLayout(false);

		}
#pragma endregion

		
		//
		//		Gd2( d ) = gamma( d/2 )
		//
		double Gd2( int d ){
			double v;
			if ((d % 2) == 0) {
				v = 1.0;
				if (((d/2) - 1) > 1){
					for (int i = (d/2) - 1; i > 1; i--)
						v *= double(i);
				}
			}else{
				v = Math::Sqrt(Math::PI);
				if ((d/2.0) > 0.6){
					for (double a1 = (d/2.0) - 1.0; a1 > 0.45; a1 -= 1.0)
						v *= a1;
				}
			}
			return v;
		}

		double chi2Distri( double x, int df ){
			return Math::Pow(x, (df/2.0) - 1.0) * Math::Exp(-x/2.0) / (Gd2(df) * Math::Pow(2.0, df/2.0));
		}
	
		int NSimu;
		double * Lambda; 

	public: System::Windows::Forms::Form ^ pf;

	public: void SetValues( int vNSimu, double * vLambda, int vdf ){
				NSimu = vNSimu;
				Lambda = vLambda;
				chi_df = vdf;
			}

			int x0, x1, y0, y1;
			int chi_df;

			int xpos( double x ){
				return int(x0 + x * (x1 - x0));
			}

			int ypos( double y ){
				return int(y0 - y * (y0 - y1));
			}

			double max_chi2;
			double max_x;
			int ncat;
			
	public: void Draw(){
				this->WindowState = System::Windows::Forms::FormWindowState::Maximized;
				Update();
				winW = this->ClientSize.Width;
				winH = this->ClientSize.Height;
				pictureBox1->Left = 0;
				pictureBox1->Top = buttonClose->Height;
				pictureBox1->Width = this->ClientSize.Width;
				pictureBox1->Height = this->ClientSize.Height - buttonClose->Height;
				int pw = pictureBox1->Width;
				int ph = pictureBox1->Height;
				pictureBox1->Image = gcnew Bitmap(pw, ph);
				Graphics ^ gf = Graphics::FromImage(pictureBox1->Image);
				Brush ^ bshWt = gcnew SolidBrush(Color::White);
				gf->FillRectangle(bshWt, 0, 0, pw, ph);
				x0 = int(pw * 0.1);
				x1 = int(pw * 0.9);
				y0 = int(ph * 0.85);
				y1 = int(ph * 0.1);
				Pen ^ pn = gcnew Pen(Color::Black, 2);
				gf->DrawRectangle(pn, xpos(00.0), ypos(1.0), xpos(1.0) - xpos(0.0), ypos(0.0) - ypos(1.0));

				qSort(Lambda, 0, NSimu - 1);

				int ipos = 0;
				while (Lambda[ipos] <= StatLambda) ipos++;
				ipos;
				double p_value = double(ipos) / NSimu;

				double LB, UB;
				CalcBinPIntvl calcI;
				calcI.calc95Intvl(NSimu, ipos + 1, LB, UB);

				
				int NPoints = 1000;
				array<Point> ^ pntdata = gcnew array<Point>(NPoints+1);

				 #define CapName System::Drawing::Drawing2D
				
				 for (int i = 0; i <= NPoints; i++)
					 pntdata[i] = Point(xpos(Lambda[int((NSimu - 1) * i / double(NPoints))]),
					 ypos(i / double(NPoints)));

				 pictureBox1->Image = pictureBox1->Image;

				 gf->DrawLines(pn, pntdata);

				String ^ str = "0";
				using System::Drawing::Font;
				Font ^ fnt = gcnew Font("lr SVbN", ypos(0.0) - ypos(0.05), GraphicsUnit::Pixel);
				Brush ^ bshBk = gcnew SolidBrush(Color::Black);
				SizeF sizeStr = gf->MeasureString( str, fnt );
				gf->DrawString( str, fnt, bshBk, xpos(0.0) - sizeStr.Width/2, ypos(-0.01) );
				gf->DrawString(str, fnt, bshBk, xpos(0.0) - int(1.5 * sizeStr.Width), ypos(0.0) - sizeStr.Height / 2);

				str = "1";	
				sizeStr = gf->MeasureString( str, fnt );
				gf->DrawString(str, fnt, bshBk, xpos(1.0) - sizeStr.Width / 2, ypos(-0.01));
				gf->DrawString(str, fnt, bshBk, xpos(0.0) - int(1.5 * sizeStr.Width), ypos(1.0) - sizeStr.Height / 2);

				gf->DrawLine(pn, xpos(StatLambda), ypos(-0.02), xpos(StatLambda), ypos(1.0));
				str = StatLambda.ToString();
				sizeStr = gf->MeasureString(str, fnt);
				gf->DrawString(str, fnt, bshBk, xpos(StatLambda) - sizeStr.Width / 2, ypos(-0.03));

				str = "Prop ";
				sizeStr = gf->MeasureString(str, fnt);
				gf->DrawString(str, fnt, bshBk, xpos(0.0) - int(1.3 * sizeStr.Width), ypos(0.5) - sizeStr.Height / 2);

				str = "Lambda";
				sizeStr = gf->MeasureString(str, fnt);
				gf->DrawString(str, fnt, bshBk, xpos(0.5) - sizeStr.Width / 2, ypos(-0.1));

				str = "Prop(samples <= " + StatLambda.ToString() + ") <p-value(est.)> = " + (100.0 * p_value).ToString("F2") + "%"
					+ "   95%CI = [" + LB.ToString("F3") + ", " + UB.ToString("F3") + "]";
				sizeStr = gf->MeasureString(str, fnt);
				gf->DrawString(str, fnt, bshBk, xpos(0.5) - sizeStr.Width / 2, ypos(1.0) - int(1.5 * sizeStr.Height));
			}

	private: System::Void buttonClose_Click(System::Object^  sender, System::EventArgs^  e) {
				 this->Close();
				 pf->Close();
			 }
	private: System::Void buttonSave_Click(System::Object^  sender, System::EventArgs^  e) {
				 saveFileDialog1->FileName = "";
				 saveFileDialog1->Filter = "BitMapFile (*.bmp)|*.bmp";
				 if(saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel) return;
				 pictureBox1->Image->Save(saveFileDialog1->FileName);
				 MessageBox::Show(saveFileDialog1->FileName + " was saved.");
				 buttonClose->Focus();
			 }
};
}
